## genometester 4.0

=== src/Makefile ===
# Project: GenomeTester v4.0

VERSION = 4.0
CXX  = gcc

# C Files

LISTMAKER_SOURCES = \
	glistmaker.c \
	common.c common.h \
	wordtable.c wordtable.h \
	wordmap.c wordmap.h \
	fasta.c fasta.h \
	buffer.c buffer.h \
	sequence.c sequence.h \
	sequence-file.c sequence-file.h \
	queue.c queue.h \
	utils.c utils.h

LISTMAKER2_SOURCES = \
	glistmaker2.c \
	wordtable.c wordtable.h \
	wordmap.c wordmap. h \
	fasta.c fasta.h \
	buffer.c buffer.h \
	sequence.c sequence.h \
	sequence-file.c sequence-file.h \
	queue.c queue.h \
	common.c common.h \
	trie.c trie.h \
	utils.c utils.h

LISTQUERY_SOURCES = \
	glistquery.c \
	wordtable.c wordtable.h \
	wordmap.c wordmap.h \
	fasta.c fasta.h \
	buffer.c buffer.h \
	sequence.c sequence.h \
	sequence-file.c sequence-file.h \
	common.c common.h \
	queue.c queue.h \
	utils.c utils.h

LISTCOMPARE_SOURCES = \
	glistcompare.c \
	wordtable.c \
	wordmap.c \
	fasta.c \
	buffer.c \
	sequence.c \
	sequence-file.c sequence-file.h \
	common.c \
	queue.c queue.h \
	utils.c

GMER_COUNTER_SOURCES = \
	gmer_counter.c \
	index.c index.h \
	trie.c trie.h \
	wordmap.c wordmap.h \
	sequence.c sequence.h \
	sequence-file.c sequence-file.h \
	wordtable.c wordtable.h \
	fasta.c fasta.h \
	thread-pool.c thread-pool.h \
	queue.c queue.h \
	utils.c utils.h \
	database.c database.h

GMER_CALLER_SOURCES = \
	binomial.c binomial.h \
	genotypes.c genotypes.h \
	simplex.c simplex.h \
	thread-pool.c thread-pool.h \
	utils.c utils.h \
	gmer_caller.c

GASSEMBLER_SOURCES = \
	binomial.c binomial.h \
	database.c database.h \
	fasta.c fasta.h \
	index.c index.h \
	matrix.c matrix.h \
	queue.c queue.h \
	sequence.c sequence.h \
	sequence-file.c sequence-file.h \
	trie.c trie.h \
	utils.c utils.h \
	wordmap.c wordmap.h \
	wordtable.c wordtable.h \
	gassembler.c

DISTRO_SOURCES = \
	binomial.c binomial.h \
	fasta.c fasta.h \
	queue.c queue.h \
	sequence.c sequence.h \
	simplex.c simplex.h \
	utils.c utils.h \
	wordmap.c wordmap.h \
	wordtable.c wordtable.h \
	distro.c

ALEQ_SOURCES = \
	binomial.c binomial.h \
	sequence.c sequence.h \
	simplex.c simplex.h \
	utils.c utils.h \
	aleq.c

RELEASEFLAGS = -O3
DEBUGFLAGS = -O0 -g
LIBS = -lm -lpthread -lrt
INCS = -I.
BINS  = glistmaker glistquery glistcompare

#CXXFLAGS = $(INCS) $(DEBUGFLAGS) -Wall 
CXXFLAGS = $(INCS) $(RELEASEFLAGS) -Wall 

.PHONY: all all-before all-after clean clean-custom

all: all-before $(BINS) all-after

glistmaker: $(LISTMAKER_SOURCES)
	$(CXX) $(LISTMAKER_SOURCES) -o glistmaker $(LIBS) $(CXXFLAGS)

glistmaker2: $(LISTMAKER2_SOURCES)
	$(CXX) $(LISTMAKER2_SOURCES) -o glistmaker2 $(LIBS) $(DEBUGFLAGS) -Wall

glistquery: $(LISTQUERY_SOURCES)
	$(CXX) $(LISTQUERY_SOURCES) -o glistquery $(LIBS) $(CXXFLAGS)

glistcompare: $(LISTCOMPARE_SOURCES)
	$(CXX) $(LISTCOMPARE_SOURCES) -o glistcompare $(LIBS) $(CXXFLAGS)

gmer_counter: $(GMER_COUNTER_SOURCES)
	$(CXX) $(GMER_COUNTER_SOURCES) -o gmer_counter $(LIBS) $(CXXFLAGS) -Wall

gmer_caller: $(GMER_CALLER_SOURCES)
	$(CXX) $(GMER_CALLER_SOURCES) -o gmer_caller $(LIBS) $(CXXFLAGS) -Wall

gassembler: $(GASSEMBLER_SOURCES)
	$(CXX) $(GASSEMBLER_SOURCES) -o gassembler $(LIBS) $(CXXFLAGS) -Wall

distro: $(DISTRO_SOURCES)
	$(CXX) $(DISTRO_SOURCES) -o distro $(LIBS) $(CXXFLAGS) -Wall

aleq: $(ALEQ_SOURCES)
	$(CXX) $(ALEQ_SOURCES) -o aleq $(LIBS) $(CXXFLAGS) -Wall
	
clean: clean-custom
	rm -f *.o $(BINS)

depend:
	$(CC) $(CFLAGS) -M *.c > .depend

include .depend

=== debian/changelog ===
genometester (4.0-1) unstable; urgency=medium

  * Initial release (Closes: #900752)
  * Add manpages
  * Add autopkgtest

 -- Liubov Chuprikova <chuprikovalv@gmail.com>  Mon, 04 Jun 2018 16:33:48 +0200

=== debian/control ===
Source: genometester
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Liubov Chuprikova <chuprikovalv@gmail.com>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~)
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/med-team/genometester
Vcs-Git: https://salsa.debian.org/med-team/genometester.git
Homepage: https://github.com/bioinfo-ut/GenomeTester4

Package: genometester
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: toolkit for performing set operations on k-mer lists
 Toolkit for performing set operations - union, intersection and
 complement - on k-mer lists.
 .
 GenomeTester4 toolkit, which contains a novel tool GListCompare for
 performing union, intersection and complement (difference) set
 operations on k-mer lists. It contains examples of how these
 general operations can be combined to solve a variety of biological
 analysis tasks.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE = 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk
# this provides:
# DEB_SOURCE: the source package name
# DEB_VERSION: the full version of the package (epoch + upstream vers. + revision)
# DEB_VERSION_EPOCH_UPSTREAM: the package's version without the Debian revision
# DEB_VERSION_UPSTREAM_REVISION: the package's version without the Debian epoch
# DEB_VERSION_UPSTREAM: the package's upstream version
# DEB_DISTRIBUTION: the distribution(s) listed in the current entry of debian/changelog

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --sourcedirectory=src

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -- gmer_counter
	dh_auto_build -- gmer_caller

=== debian/watch ===
version=4

opts="uversionmangle=s/_/./g" \
  https://github.com/bioinfo-ut/GenomeTester4/releases .*/archive/Version_(\d[_.\d]+)@ARCHIVE_EXT@

## genometester 4.0+git20180508.a9c14a6+dfsg

=== src/Makefile ===
--- 
+++ 
@@ -8,9 +8,9 @@
 LISTMAKER_SOURCES = \
 	glistmaker.c \
 	common.c common.h \
+	fasta.c fasta.h \
 	wordtable.c wordtable.h \
 	wordmap.c wordmap.h \
-	fasta.c fasta.h \
 	buffer.c buffer.h \
 	sequence.c sequence.h \
 	sequence-file.c sequence-file.h \
@@ -44,6 +44,18 @@
 
 LISTCOMPARE_SOURCES = \
 	glistcompare.c \
+	wordtable.c \
+	wordmap.c \
+	fasta.c \
+	buffer.c \
+	sequence.c \
+	sequence-file.c sequence-file.h \
+	common.c \
+	queue.c queue.h \
+	utils.c
+
+GDISTRIBUTION_SOURCES = \
+	gdistribution.c \
 	wordtable.c \
 	wordmap.c \
 	fasta.c \
@@ -134,6 +146,9 @@
 glistcompare: $(LISTCOMPARE_SOURCES)
 	$(CXX) $(LISTCOMPARE_SOURCES) -o glistcompare $(LIBS) $(CXXFLAGS)
 
+gdistribution: $(GDISTRIBUTION_SOURCES)
+	$(CXX) $(GDISTRIBUTION_SOURCES) -o gdistribution $(LIBS) $(CXXFLAGS)
+
 gmer_counter: $(GMER_COUNTER_SOURCES)
 	$(CXX) $(GMER_COUNTER_SOURCES) -o gmer_counter $(LIBS) $(CXXFLAGS) -Wall

=== debian/changelog ===
genometester (4.0+git20180508.a9c14a6+dfsg-1) unstable; urgency=medium

  * Remove binaries from upstream source
  * Use git mode in watch file since gdistribution is needed by some
    dependencies
  * Standards-Version: 4.2.1
  * Install gdistribution

 -- Andreas Tille <tille@debian.org>  Sat, 06 Oct 2018 12:04:26 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper (>= 11~)
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/med-team/genometester
 Vcs-Git: https://salsa.debian.org/med-team/genometester.git
 Homepage: https://github.com/bioinfo-ut/GenomeTester4

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE = 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --sourcedirectory=src

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -- gmer_counter
	dh_auto_build -- gmer_caller
	dh_auto_build -- gdistribution

=== debian/watch ===
version=4

opts="mode=git,pretty=4.0+git%cd.%h,repacksuffix=+dfsg,dversionmangle=auto,uversionmangle=s/_/./g,repack,compression=xz" \
   https://github.com/bioinfo-ut/GenomeTester4.git HEAD

#  https://github.com/bioinfo-ut/GenomeTester4/releases .*/archive/Version_(\d[_.\d]+)@ARCHIVE_EXT@

## genometester 4.0+git20200511.91cecb5+dfsg

=== debian/changelog ===
genometester (4.0+git20200511.91cecb5+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 12 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse. (routine-update)
  * Added d/TODO to indicate missing man page (also a lintian warning)
  * Improved clean.

 -- Steffen Moeller <moeller@debian.org>  Sun, 17 May 2020 20:06:55 +0200

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,12 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~)
-Standards-Version: 4.2.1
+Build-Depends: debhelper-compat (= 12)
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/genometester
 Vcs-Git: https://salsa.debian.org/med-team/genometester.git
 Homepage: https://github.com/bioinfo-ut/GenomeTester4
+Rules-Requires-Root: no
 
 Package: genometester
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -16,3 +16,7 @@
 	dh_auto_build -- gmer_counter
 	dh_auto_build -- gmer_caller
 	dh_auto_build -- gdistribution
+
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -f src/gdistribution src/gmer_caller src/gmer_counter

## genometester 4.0+git20221122.71e6625

=== src/Makefile ===
# Project: GenomeTester v4.0

VERSION = 4.0
CXX  = gcc

# C Files

LISTMAKER_SOURCES = \
	glistmaker.c \
	listmaker-queue.c listmaker-queue.h \
	queue.c queue.h \
	bloom.c bloom.h \
	fasta.c fasta.h \
	file-array.c file-array.h \
	buffer.c buffer.h \
	sequence.c sequence.h \
	sequence-block.c sequence-block.h \
	sequence-collection.c sequence-collection.h \
	sequence-file.c sequence-file.h \
	sequence-source.c sequence-source.h \
	sequence-stream.c sequence-stream.h \
	sequence-zstream.c sequence-zstream.h \
	set-operations.c set-operations.h \
	common.c common.h \
	utils.c utils.h \
	word-array-sorted.c word-array-sorted.h \
	word-dict.c word-dict.h \
	word-list.c word-list.h \
	word-list-sorted.c word-list-sorted.h \
	word-list-stream.c word-list-stream.h \
	word-map.c word-map.h \
	word-table.c word-table.h

LISTQUERY_SOURCES = \
	glistquery.c \
	listmaker-queue.c listmaker-queue.h \
	fasta.c fasta.h \
	bloom.c bloom.h \
	buffer.c buffer.h \
	file-array.c file-array.h \
	index-map.c index-map.h \
	sequence.c sequence.h \
	sequence-collection.c sequence-collection.h \
	sequence-block.c sequence-block.h \
	sequence-file.c sequence-file.h \
	sequence-source.c sequence-source.h \
	sequence-stream.c sequence-stream.h \
	sequence-zstream.c sequence-zstream.h \
	set-operations.c set-operations.h \
	common.c common.h \
	queue.c queue.h \
	utils.c utils.h \
	word-array-sorted.c word-array-sorted.h \
	word-dict.c word-dict.h \
	word-index.c word-index.h \
	word-list.c word-list.h \
	word-list-sorted.c word-list-sorted.h \
        word-list-stream.c word-list-stream.h \
        word-map.c word-map.h \
	word-table.c word-table.h

LISTCOMPARE_SOURCES = \
	glistcompare.c \
	listmaker-queue.c listmaker-queue.h \
	bloom.c bloom.h \
	fasta.c \
	buffer.c \
	file-array.c file-array.h \
	index-map.c index-map.h \
	sequence.c \
	sequence-collection.c sequence-collection.h \
	sequence-block.c sequence-block.h \
	sequence-file.c sequence-file.h \
	sequence-source.c sequence-source.h \
	sequence-stream.c sequence-stream.h \
	sequence-zstream.c sequence-zstream.h \
	common.c \
	queue.c queue.h \
	utils.c \
	word-array-sorted.c word-array-sorted.h \
	word-dict.c word-dict.h \
	word-index.c word-index.h \
	word-list.c word-list.h \
	word-list-sorted.c word-list-sorted.h \
	word-list-stream.c word-list-stream.h \
	word-map.c word-map.h \
	word-table.c word-table.h

GMER_COUNTER_SOURCES = \
	gmer_counter.c \
	database.c database.h \
	index.c index.h \
	listmaker-queue.c listmaker-queue.h \
	trie.c trie.h \
	sequence.c sequence.h \
	sequence-collection.c sequence-collection.h \
	sequence-block.c sequence-block.h \
	sequence-file.c sequence-file.h \
	sequence-source.c sequence-source.h \
	sequence-stream.c sequence-stream.h \
	sequence-zstream.c sequence-zstream.h \
	fasta.c fasta.h \
	thread-pool.c thread-pool.h \
	queue.c queue.h \
	utils.c utils.h \
	word-list.c word-list.h \
	word-table.c word-table.h

GMER_CALLER_SOURCES = \
	binomial.c binomial.h \
	genotypes.c genotypes.h \
	simplex.c simplex.h \
	thread-pool.c thread-pool.h \
	utils.c utils.h \
	gmer_caller.c

GINDEXER_SOURCES = \
	gindexer.c \
	fasta.c fasta.h \
	sequence.c sequence.h \
	sequence-source.c sequence-source.h \
	sequence-stream.c sequence-stream.h

GASSEMBLER_SOURCES = \
	binomial.c binomial.h \
	database.c database.h \
	fasta.c fasta.h \
	index.c index.h \
	matrix.c matrix.h \
	queue.c queue.h \
	sequence.c sequence.h \
	sequence-block.c sequence-block.h \
	sequence-collection.c sequence-collection.h \
	sequence-file.c sequence-file.h \
	sequence-source.c sequence-source.h \
	trie.c trie.h \
	utils.c utils.h \
	gassembler.c

ALEQ_SOURCES = \
	binomial.c binomial.h \
	sequence.c sequence.h \
	simplex.c simplex.h \
	utils.c utils.h \
	aleq.c

KMER_PREDICTOR_SOURCES = \
	utils.c utils.h \
	word-list-stream.c word-list-stream.h \
	word-array-sorted.c word-array-sorted.h \
	word-list.c word-list.h \
	kmer-predictor.c

ARIKKEI_SOURCES = \
	libarikkei/arikkei-strlib.c libarikkei/arikkei-strlib.h \
	libarikkei/arikkei-utils.c libarikkei/arikkei-utils.h

AZ_SOURCES = \
	az/base.h \
	az/class.c az/class.h \
	az/interface.c az/interface.h \
	az/reference.c az/reference.h \
	az/object.c az/object.h \
	az/primitives.c az/primitives.h \
	az/serialization.c az/serialization.h \
	az/types.c az/types.h

RELEASEFLAGS = -O3
DEBUGFLAGS = -O0 -g
AZ_FLAGS = -DAZ_NO_PROPERTIES -DAZ_NO_STRING -DAZ_NO_VALUE
LIBS = -lm -lpthread -lrt -lz
INCS = -I.
BINS  = glistmaker glistquery glistcompare

#CXXFLAGS = $(INCS) $(DEBUGFLAGS) -Wall 
CXXFLAGS = $(INCS) $(RELEASEFLAGS) -Wall -std=c99 -D_DEFAULT_SOURCE -D_GNU_SOURCE -D_POSIX_C_SOURCE=200809L -D_XOPEN_SOURCE

.PHONY: all all-before all-after clean clean-custom

all: all-before $(BINS) all-after

glistmaker: $(LISTMAKER_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES)
	$(CXX) $(LISTMAKER_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES) -o glistmaker $(LIBS) $(CXXFLAGS) $(AZ_FLAGS)

glistquery: $(LISTQUERY_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES)
	$(CXX) $(LISTQUERY_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES) -o glistquery $(LIBS) $(CXXFLAGS) $(AZ_FLAGS)

glistcompare: $(LISTCOMPARE_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES)
	$(CXX) $(LISTCOMPARE_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES) -o glistcompare $(LIBS) $(CXXFLAGS) $(AZ_FLAGS)

gindexer: $(GINDEXER_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES)
	$(CXX) $(GINDEXER_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES) -o gindexer $(LIBS) $(CXXFLAGS) $(AZ_FLAGS)

gmer_counter: $(GMER_COUNTER_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES)
	$(CXX) $(GMER_COUNTER_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES) -o gmer_counter $(LIBS) $(CXXFLAGS) $(AZ_FLAGS)

gmer_caller: $(GMER_CALLER_SOURCES)
	$(CXX) $(GMER_CALLER_SOURCES) -o gmer_caller $(LIBS) $(CXXFLAGS) -Wall

gassembler: $(GASSEMBLER_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES)
	$(CXX) $(GASSEMBLER_SOURCES) $(AZ_SOURCES) $(ARIKKEI_SOURCES) -o gassembler $(LIBS) $(CXXFLAGS) $(AZ_FLAGS)

aleq: $(ALEQ_SOURCES)
	$(CXX) $(ALEQ_SOURCES) -o aleq $(LIBS) $(CXXFLAGS) -Wall

kmer_predictor: $(KMER_PREDICTOR_SOURCES)
	$(CXX) $(KMER_PREDICTOR_SOURCES)  $(AZ_SOURCES) $(ARIKKEI_SOURCES) -o kmer_predictor $(LIBS) $(AZ_FLAGS) $(CXXFLAGS)
	
clean: clean-custom
	rm -f *.o $(BINS)

depend:
	$(CC) $(CFLAGS) -M *.c > .depend

include .depend

=== debian/changelog ===
genometester (4.0+git20221122.71e6625-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * New upstream version
  * d/watch:
     - detect new versions on github
     - version=5
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add missing build dependency on dh addon.
  * Build-Depends: zlib1g-dev
  * Standards-Version: 4.7.2 (routine-update)

  [ Helmut Grohne ]
  * Fix C vs C++ confusion by rather calling CC for C code
    Closes: #1107684

  [ Étienne Mollier ]
  * default-wordlength.patch: new: set a sane default.
    glistmaker defaults to have a wordlength of 0, out of the acceptable
    length of 1 to 32.  This patch restores the previous behavior, which
    looks to have been to default to a wordlength of 16, given autopkgtest
    expectations.
  * gdistribution.patch: new: fix build failure of this binary.
  * d/{install,rules}: build gassembler.
  * buildflags.patch: new: improve hardening by passing CPP and LDFLAGS.
  * d/patches/*: normalize Last-Update timestamps.
  * d/control: drop redundant Priority: optional.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/control: declare compliance to standards version 4.7.3.

 -- Étienne Mollier <emollier@debian.org>  Fri, 30 Jan 2026 18:39:54 +0100

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Uploaders: Liubov Chuprikova <chuprikovalv@gmail.com>,
            Andreas Tille <tille@debian.org>
 Section: science
-Priority: optional
-Build-Depends: debhelper-compat (= 12)
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 13),
+               debhelper,
+               zlib1g-dev
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/genometester
 Vcs-Git: https://salsa.debian.org/med-team/genometester.git
 Homepage: https://github.com/bioinfo-ut/GenomeTester4
-Rules-Requires-Root: no
 
 Package: genometester
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,7 @@
 	dh_auto_build
 	dh_auto_build -- gmer_counter
 	dh_auto_build -- gmer_caller
+	dh_auto_build -- gassembler
 	dh_auto_build -- gdistribution
 
 override_dh_auto_clean:

=== debian/watch ===
Version: 5

Source: https://github.com/bioinfo-ut/GenomeTester4.git
Matching-Pattern: HEAD
Mode: git
Git-Pretty: 4.0+git%cd.%h
